#<profile4xi profile = "11" /> 
# -------------------------------------------------------------------------------------------------
#<program4xi program = "fire2500four4xi.py">
#<abstract4xi abstract = "fires to direction four and to distance 2500"/>
#<verify4xi verification = "11" target = "verb4xi.py"/>
#<refer4xi reference = "verb4xi.py"/>
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
6#<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'fire2500four4xi']
#"
#/>


# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
import sys
import threading                
import _thread
import _winapi
   

import signal
import itertools
import weakref
import logging 

from math import pi
from math import sin
from math import cos 
from math import fabs
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "


from time4xi import time4xi

#"
#/>

       
# -------------------------------------------------------------------------------------------------
# SHOT2FOUR - COORDINATE SIGNS OF SHOOT2FOUR4XI: (X + ,Y - ,Z + )
# -------------------------------------------------------------------------------------------------    
global shot2four25004xi


#"
#/>

# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
ack2debug = False
shot2four25004xi = {
                1:'1002x-2252y416z',
                2:'1019x-1680y1544z',
                3:'1026x-791y2138z',
                4:'1027x-81y2277z',
                5:'1052x-28y2267z',
                6:'1071x-1264y1871z',
                7:'1083x-748y2124z',
                8:'1114x-1637y1524z',
                9:'1120x-2200y391z',
                10:'1139x-701y2111z',
                11:'1149x-1219y1854z',
                12:'1193x-651y2098z',
                13:'1208x-1589y1504z',
                14:'1225x-1170y1837z',
                15:'1236x-2141y366z',
                16:'1244x-596y2084z',
                17:'127x-2426y587z',
                18:'1293x-539y2070z',
                19:'1298x-1117y1820z',
                20:'1299x-1535y1484z',
                21:'1338x-477y2056z',
                22:'1348x-2076y341z',
                23:'1369x-1058y1803z',
                24:'1381x-412y2042z',
                25:'1388x-1475y1464z',
                26:'1421x-344y2027z',
                27:'1437x-995y1786z',
                28:'1457x-2006y317z',
                29:'1457x-273y2012z',
                30:'1473x-1411y1444z',
                31:'1489x-199y1997z',
                32:'148x-113y2493z',
                33:'1503x-928y1768z',
                34:'1517x-122y1982z',
                35:'1541x-43y1967z',
                36:'1556x-1341y1423z',
                37:'1562x-1929y292z',
                38:'1565x-857y1750z',
                39:'1623x-781y1733z',
                40:'1635x-1266y1403z',
                41:'1663x-1847y267z',
                42:'1678x-702y1714z',
                43:'169x-479y2447z',
                44:'1711x-1187y1382z',
                45:'1728x-619y1696z',
                46:'174x-119y2491z',
                47:'1759x-1759y242z',
                48:'1774x-532y1678z',
                49:'1782x-1103y1361z',
                50:'1816x-442y1659z',
                51:'1850x-1015y1340z',
                52:'1850x-1666y217z',
                53:'1853x-350y1640z',
                54:'1885x-255y1621z',
                55:'1912x-157y1602z',
                56:'1912x-922y1319z',
                57:'1933x-57y1583z',
                58:'1937x-1568y192z',
                59:'1970x-826y1298z',
                60:'2017x-1466y167z',
                61:'202x-123y2488z',
                62:'203x-492y2442z',
                63:'2093x-1359y142z',
                64:'2103x-755y1327z',
                65:'2162x-1248y117z',
                66:'2225x-1134y92z',
                67:'2283x-1016y67z',
                68:'230x-124y2486z',
                69:'2333x-895y42z',
                70:'2377x-772y17z',
                71:'239x-503y2437z',
                72:'254x-2422y563z',
                73:'258x-122y2483z',
                74:'277x-511y2431z',
                75:'287x-118y2480z',
                76:'316x-516y2425z',
                77:'317x-111y2477z',
                78:'346x-101y2473z',
                79:'356x-519y2419z',
                80:'375x-89y2470z',
                81:'381x-2411y538z',
                82:'398x-519y2412z',
                83:'403x-73y2466z',
                84:'409x-994y2256z',
                85:'431x-55y2461z',
                86:'440x-516y2406z',
                87:'458x-35y2457z',
                88:'470x-992y2245z',
                89:'483x-11y2452z',
                90:'483x-509y2399z',
                91:'508x-2393y514z',
                92:'526x-500y2392z',
                93:'532x-986y2234z',
                94:'570x-487y2384z',
                95:'595x-975y2223z',
                96:'614x-471y2377z',
                97:'634x-2368y489z',
                98:'657x-452y2369z',
                99:'657x-961y2211z',
                100:'667x-1412y1952z',
                101:'700x-429y2361z',
                102:'720x-943y2200z',
                103:'742x-403y2352z',
                104:'749x-1392y1936z',
                105:'759x-2336y465z',
                106:'783x-374y2344z',
                107:'783x-921y2188z',
                108:'823x-341y2335z',
                109:'831x-1367y1920z',
                110:'845x-894y2175z',
                111:'862x-305y2326z',
                112:'881x-2297y440z',
                113:'899x-266y2317z',
                114:'906x-864y2163z',
                115:'912x-1338y1904z',
                116:'923x-1718y1564z',
                117:'935x-224y2307z',
                118:'967x-829y2150z',
                119:'968x-179y2297z',
                120:'992x-1303y1887z',
                121:'998x-131y2287z'}
#"
#"/>
    

# -------------------------------------------------------------------------------------------------
#<function4xi function = "fire2500four4xi" usage = "target function for charge25004xi with Process4Xi">
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
def fire2500four4xi(queue2four, consumer_channel2four, publisher_channel2four):
    '''
    returns (x,y,z) coordinates via queue
    '''
    
    # -------------------------------------------------------------------------------------------------
    # PARAMETERS                   
    # -------------------------------------------------------------------------------------------------                                                               
    
    time2start = time4xi()
    if ack2debug is True:
        print("\n (STEP 1A1/33) OF FIRE2500FOUR4XI - STARTED TIME: ", time2start)
        # 
        
        print("\n (STEP 1A2/33) OF FIRE2500FOUR4XI -  QUEUE2FOUR: ", queue2four)      
        # 
        
        print("\n (STEP 1A3/33) OF FIRE2500FOUR4XI -  CONSUMER_CHANNEL2FOUR: ", consumer_channel2four)
        # 
              
        print("\n (STEP 1A4/33) OF FIRE2500FOUR4XI -  PUBLISHER_CHANNEL2FOUR: ", publisher_channel2four)          
        # 
        


    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # QUEUE RETURNING
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    ack2put = False
    if ack2debug is True:
        print("\n (STEP 2A/33) OF FIRE2500FOUR4XI - TRYING TO RETURN BY PUTTING COORDINATE DICTIONARY TO QUEUE2FOUR: ", queue2four, " - TIME: ", time4xi()) 
        # 
         
    try:
        # ------------------------------------------------------------------------------------- 
        # PUT SHOT TO QUEUE 
        # -------------------------------------------------------------------------------------                 
        queue2four.put(shot2four25004xi)
        if ack2debug is True:
            print("\n (STEP 2B/33) OF FIRE2500FOUR4XI - SUCCEEDED TO PUT COORDINATE DICTIONARY TO QUEUE2FOUR: ", queue2four, " - TIME: ", time4xi()) 
            # 
             
        ack2put = True
    except:
        print("\n (STEP 2C/33) OF FIRE2500FOUR4XI *** FAILED TO PUT COORDINATE DICTIONARY TO QUEUE2FOUR: ", queue2four, " - TIME: ", time4xi()) 
    
    if ack2debug is True:
        print("\n (STEP 3A/33) OF FIRE2500FOUR4XI - TRYING TO INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER_CHANNEL2FOUR: ", publisher_channel2four, " - TIME: ", time4xi())
        # 
         
    try:                
        # ---------------------------------------------------------------------------------------------
        # INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER CHANNEL 
        # ---------------------------------------------------------------------------------------------
        if ack2put is True:
            message2send4one = "<ack2put4xi>queue2four8shot2four25004xi</ack2put4xi>"
        else:
            message2send4one = "<nack2put4xi>queue2four8shot2four25004xi</nack2put4xi>" 
            
        publisher_channel2four.send(message2send4one)
        if ack2debug is True:    
            print(" (STEP 3B/33) OF FIRE2500FOUR4XI -  SENT MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2FOUR: ", publisher_channel2four, " - TIME: ", time4xi()) 
            #  
        
    except:
        print(" (STEP 3C/33) OF FIRE2500FOUR4XI *** FAILED TO SEND MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2FOUR: ", publisher_channel2four, " - TIME: ", time4xi()) 
    
    if ack2debug is True:        
        print("\n (STEP 3D/33) OF FIRE2500FOUR4XI - RETURNING QUEUE OBJECT QUEUE2FOUR: ", queue2four, " - TIME: ", time4xi())  
        # 
            
    return queue2four    
        
           
#</function4xi>


#</program4xi>
# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_verb4xi.txt
#   sense-test-verb4xi.xml
#   reason-test-verb4xi.xml
#   ace-test-verb4xi.xml
#"
#>



# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of fire2500four4xi.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>
                                    